Texture2D g_Texture;
RasterizerState NotCull
{
	CullMode = NONE;
    MultisampleEnable = FALSE;
};

DepthStencilState Draw2D_DepthState
{
	StencilEnable = false;
	DepthEnable = false;
};

struct PS_INPUT
{
    float4 Pos : SV_POSITION;
	float2 Tex : TEXCOORD;
};

struct PS_INPUT1
{
    float4 Pos : SV_POSITION;
};

uint vxCount,vyCount;
float srcWidth,srcHeight;
float newWidth,newHeight;

SamplerState Sampler
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

PS_INPUT VS(float2 vPos : POSITION, uint vId : SV_VertexID)
{
    PS_INPUT Output;
	Output.Pos = float4(2*vPos.x/newWidth-1, 1-2*vPos.y/newHeight, 0.0f, 1.0f );
	//Output.Pos = float4(vPos.x/1000, vPos.y/1000, 0.0f, 1.0f );
	float src_xi=vId%vxCount;
	float src_yi=vId/vxCount;
	float src_xRatio = src_xi/(vxCount-1);
	float src_yRatio = 1-src_yi/(vyCount-1);
	Output.Tex = float2(src_xRatio,src_yRatio);
	//Output.Tex = float2(vPos.x/newWidth,1-vPos.y/newHeight);
	return Output;
}

PS_INPUT1 VS1(float2 vPos : POSITION)
{
	PS_INPUT1 output;
	output.Pos = float4(2*vPos.x/newWidth-1, 1-2*vPos.y/newHeight, 0.0f, 1.0f );
	return output;
}

float4 PS( PS_INPUT In ) : SV_Target
{
	return g_Texture.Sample( Sampler, In.Tex );
}

float4 PS1( PS_INPUT1 In ) : SV_Target
{
	return float4(0,0,1,1);
}

technique11 Draw2DInterop
{
    pass P0
	{
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetGeometryShader( NULL );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
		SetRasterizerState( NULL );
		SetDepthStencilState( Draw2D_DepthState,0 );
		SetBlendState( NULL, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF );
	}
	pass P1
	{
		SetVertexShader( CompileShader( vs_4_0, VS1() ) );
		SetGeometryShader( NULL );
		SetPixelShader( CompileShader( ps_4_0, PS1() ) );
		SetRasterizerState( NULL );
		SetDepthStencilState( Draw2D_DepthState,0 );
		SetBlendState( NULL, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF );
	}
}
